/*
 * Copyright 2013 Sam Elsharif
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package info.msxlaunchers.openmsx.launcher.ui;

import com.google.inject.AbstractModule;
import com.google.inject.name.Names;

/**
 * @since v1.2
 * @author Sam Elsharif
 *
 */
public class AppModule extends AbstractModule
{
	private final String userDataDirectory;
	private final String extraDataDirectory;
	private final String generationMSXURL;

	public AppModule( String userDataDirectory, String extraDataDirectory, String generationMSXURL )
	{
		this.userDataDirectory = userDataDirectory;
		this.extraDataDirectory = extraDataDirectory;
		this.generationMSXURL = generationMSXURL;
	}

	@Override 
	protected void configure()
	{
		bind( String.class ).annotatedWith( Names.named( "UserDataDirectory" ) ).toInstance( userDataDirectory );
		bind( String.class ).annotatedWith( Names.named( "ExtraDataDirectory" ) ).toInstance( extraDataDirectory );
		bind( String.class ).annotatedWith( Names.named( "GenerationMSXURL" ) ).toInstance( generationMSXURL );
	}
}